﻿using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;  //加入參考Xna.Framework
using Microsoft.Xna.Framework.Graphics;  //加入參考Xna.Framework.Graphics
using Microsoft.Xna.Framework.Input;

namespace ComputerGame_exercise1_95156112
{
    class ClassSprite
    {
        public Texture2D texture;  //sprite是2D texture
        public Vector2 position;  //sprite的位址
        private Vector2 screenSize;  //視窗大小
        public Vector2 velocity = Vector2.Zero;  //sprite移動的速度

        //ClassSprite的constructor
        public ClassSprite(Texture2D texture, Vector2 position, Vector2 screenSize)
        {
            this.texture = texture;
            this.position = position;
            this.screenSize = screenSize;
        }

        //ClassSprite的移動function
        public void Move()
        {
            //sprite的右緣碰到視窗右邊，要反方向彈回
            if (position.X + texture.Width + velocity.X > screenSize.X)
                velocity.X = -velocity.X;
            
            //sprite的下緣碰到視窗底邊，要反方向彈回
            if (position.Y + texture.Height + velocity.Y > screenSize.Y)
                velocity.Y = -velocity.Y;

            //sprite的左緣碰到視窗左邊，要反方向彈回
            if (position.X + velocity.X < 0)
                velocity.X = -velocity.X;

            //sprite的上緣碰到視窗上邊，要反方向彈回
            if (position.Y + velocity.Y < 0)
                velocity.Y = -velocity.Y;

            position += velocity;  //以速度來更新位址
        }

        //檢查sprite是否碰撞的function
        public bool Collides(ClassSprite other)
        {
            return (this.position.X + texture.Width > other.position.X &&
                    this.position.X < other.position.X + other.texture.Width &&
                    this.position.Y + texture.Height > other.position.Y &&
                    this.position.Y < other.position.Y + other.texture.Height);
        }
    }
}
