﻿using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

namespace ComputerGame_exercise1_95156112
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;
        ClassSprite mySprite1;  //宣告sprite1
        ClassSprite mySprite2;  //宣告sprite2

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
            this.IsMouseVisible = true;  //設定滑鼠游標可以顯示
            graphics.PreferredBackBufferWidth = 500;  //視窗的預設寬
            graphics.PreferredBackBufferHeight = 400; //視窗的預設高
        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            //Add your initialization logic here
            this.Window.Title = "資四A 95156112 馬偉倫";  //設定遊戲視窗的標題

            base.Initialize();
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);

            //use this.Content to load your game content here
            //上載圖形
            Texture2D texture = Content.Load<Texture2D>("CD");
            
            //產生sprite物件
            mySprite1 = new ClassSprite(texture, new Vector2(0f, 0f),
                                        new Vector2(graphics.GraphicsDevice.Viewport.Width,
                                                    graphics.GraphicsDevice.Viewport.Height));
            mySprite1.velocity = new Vector2(5, 5);

            mySprite2 = new ClassSprite(texture, new Vector2(300f, 300f),
                                        new Vector2(graphics.GraphicsDevice.Viewport.Width,
                                                    graphics.GraphicsDevice.Viewport.Height));
            mySprite2.velocity = new Vector2(5, 5);
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // Allows the game to exit
            KeyboardState keyboardState;  //宣告一個KeyboardState的變數
            keyboardState = Keyboard.GetState();  //得到鍵盤的按鍵情況
            if (keyboardState.IsKeyDown(Keys.Escape))  //若Escape被按下
                this.Exit();  //離開遊戲

            //Add your update logic here
            MouseState mouseState = Mouse.GetState();  //宣告一個MouseState的變數並得到mouseState
            if (mouseState.LeftButton == ButtonState.Pressed)  //若滑鼠左鍵被按下
            {
                //上傳圖形
                Texture2D texture = Content.Load<Texture2D>("CD");
                //重新產生mySprite2，圖形位址就是滑鼠的位址
                mySprite2 = new ClassSprite(texture, new Vector2(mouseState.X, mouseState.Y),
                                            new Vector2(graphics.GraphicsDevice.Viewport.Width,
                                                        graphics.GraphicsDevice.Viewport.Height));
                mySprite2.velocity = new Vector2(-5, -5);
            }

            mySprite1.Move();  //移動sprite1
            mySprite2.Move();  //移動sprite2

            if (mySprite1.Collides(mySprite2))  //如果碰撞，mySprite1跟mySprite2的位址就會相同，造成mySprite2消失的假象
            {
                mySprite2.position = mySprite1.position;
            }

            base.Update(gameTime);
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            graphics.GraphicsDevice.Clear(Color.CornflowerBlue);

            //Draw mySprite1與mySprite2
            spriteBatch.Begin(SpriteBlendMode.AlphaBlend);
            spriteBatch.Draw(mySprite1.texture, mySprite1.position, Color.White);
            spriteBatch.Draw(mySprite2.texture, mySprite2.position, Color.White);
            spriteBatch.End();

            base.Draw(gameTime);
        }
    }
}
